/**
 * Created by robin on 11/1/15.
 */

(function () {
    'use strict';

    angular.module('luticateAuth')
        .factory('luticateAuthCache', ['localStorageService', function (localStorageService) {

            var luticateAuthCache = {};

            luticateAuthCache.setUser = function(user)
            {
                localStorageService.set('lu_user', user);
            };

            luticateAuthCache.getUser = function()
            {
                return localStorageService.get('lu_user');
            };

            luticateAuthCache.getToken = function()
            {
                var user = luticateAuthCache.getUser();
                if (user == null) {
                    return null;
                }
                return user.Token;
            };

            luticateAuthCache.removeUser = function()
            {
                localStorageService.remove('lu_user');
                luticateAuthCache.removeEffectivePermissions();
            };

            luticateAuthCache.setEffectivePermissions = function(permissions)
            {
                localStorageService.set('lu_effective_permissions', permissions);
            };

            luticateAuthCache.getEffectivePermissions = function()
            {
                return localStorageService.get('lu_effective_permissions');
            };

            luticateAuthCache.hasEffectivePermission = function(permission_name)
            {
                var permissions = luticateAuthCache.getEffectivePermissions();
                if (permissions == null) {
                    return null;
                }
                var value = permissions[permission_name];
                return value == null ? null : value;
            };

            luticateAuthCache.removeEffectivePermissions = function()
            {
                localStorageService.remove('lu_effective_permissions');
            };

            return luticateAuthCache;
        }]);
})();