/**
 * Created by robin on 11/1/15.
 */

(function () {
    'use strict';
    angular.module('luticateAuth')
        .factory('luticateAuthPermissions', ['luticateRequest',
            function(luticateRequest) {

                var luticateAuthPermissions = {};

                luticateAuthPermissions.getAll = function(data, promise)
                {
                    return luticateRequest.get("/api/luticate/permissions", data, promise);
                };

                luticateAuthPermissions.edit = function(data, promise)
                {
                    return luticateRequest.post("/api/luticate/permissions/" + data.permission_name + "/edit/"
                        + data.permission_value, null, null, promise);
                };

                luticateAuthPermissions.add = function(data, promise)
                {
                    return luticateRequest.post("/api/luticate/permissions/add/" + data.permission_name + "/"
                        + data.permission_value, null, null, promise);
                };

                luticateAuthPermissions.del = function(data, promise)
                {
                    return luticateRequest.post("/api/luticate/permissions/" + data.permission_name + "/del",
                        null, null, promise);
                };

                luticateAuthPermissions.getEffectiveUser = function(data, promise)
                {
                    return luticateRequest.get("/api/luticate/permissions/effective/" + data.user_id
                        + "/" + data.permission_name, null, promise);
                };

                luticateAuthPermissions.getAllEffectiveUser = function(data, promise)
                {
                    return luticateRequest.get("/api/luticate/permissions/effective/" + data.user_id, null, promise);
                };

                luticateAuthPermissions.getEffectiveMe = function(data, promise)
                {
                    return luticateRequest.get("/api/luticate/permissions/effective/me/"
                        + data.permission_name, null, promise);
                };

                luticateAuthPermissions.getAllEffectiveMe = function(promise)
                {
                    return luticateRequest.get("/api/luticate/permissions/effective/me", null, promise);
                };


                return luticateAuthPermissions;
        }]);
})();